/*
 * Copyright European Organization for Nuclear Research (CERN)
 * All rights reserved
 *
 * Author:	Vasilis.Vlachoudis@cern.ch
 * Date:	04-Feb-2010
 */

#ifndef __GEOMETRY_ARBGBODY_H
#define __GEOMETRY_ARBGBODY_H

#include "gbody.h"

// ================================= GARBBody ==================================
class GARBBody : public GBody {
private:
	int	faces[6];	// faces
public:
	GARBBody(const std::string& aname) : GBody(aname, Type::ARB) {}
	virtual	void	set(int n, double *);
	virtual	int	get(double *)	const;
	//virtual	void	position(const Point& r);
	//virtual	void	save();
	//virtual	void	restore();
	virtual void	move(int item, const Point& r, const Vector& w);
	virtual	void	rotate(const double angle, const Vector& axis);

// FIXME
//	virtual	double	distance(const double x, const double y, const double z) const;

protected:
	virtual	void	createQuads();
	virtual	void	createMesh();
	virtual	void	_updateBBox();
#ifdef USE_OBBOX
	virtual	void	_updateOBB(bool in=false);
#endif
private:
		int	faceVertices(int f, int v[4], Point* V[4]);
}; // GARBBody

#endif
